(() => {
  var __defProp = Object.defineProperty;
  var __name = (target, value) => __defProp(target, "name", { value, configurable: true });

  // ../../../build/app/ui/obj/kmwuifloat.js
  var _a;
  var keymanweb = window.keyman;
  if (!keymanweb) {
    throw new Error("`keyman` global is missing; Keyman Engine for Web script has not been loaded");
  } else if (!((_a = keymanweb.ui) === null || _a === void 0 ? void 0 : _a.name)) {
    try {
      const util = keymanweb.util;
      if (util.isTouchDevice()) {
        throw "";
      }
      const _UIFloat = class _UIFloat {
        constructor() {
          this.name = "float";
          this.KeyboardSelector = null;
          this.outerDiv = null;
          this.innerDiv = null;
          this.oskButton = null;
          this.kbdIcon = null;
          this.selecting = false;
          this.updateList = true;
          this.updateTimer = 0;
          this.floatRight = false;
          this.initialized = false;
          this.initTimer = 0;
          this.toggleOSK = () => {
            keymanweb.activatingUI(true);
            let osk = keymanweb.osk;
            if (osk && osk.show) {
              if (osk.isEnabled()) {
                osk.hide();
              } else {
                osk.show(true);
              }
            }
            if (window.event) {
              window.event.returnValue = false;
            }
            keymanweb.focusLastActiveElement();
            keymanweb.activatingUI(false);
            return false;
          };
          this.initialize = () => {
            if (this.initTimer) {
              window.clearTimeout(this.initTimer);
              this.initTimer = null;
            }
            if (!keymanweb.initialized) {
              this.initTimer = window.setTimeout(this.initialize, 50);
              return;
            }
            if (this.initialized || util.isTouchDevice()) {
              return;
            }
            const imgPath = util.getOption("resources") + "ui/float/";
            this.outerDiv = util.createElement("div");
            this.innerDiv = util.createElement("div");
            this.kbdIcon = util.createElement("img");
            this.outerDiv.innerHTML = "<a href='http://keyman.com/web/' target='KeymanWebHelp'><img src='" + imgPath + "kmicon.gif' border='0' style='padding: 0px 2px 0 1px; margin:0px;' title='KeymanWeb' alt='KeymanWeb' /></a>";
            var s = this.outerDiv.style;
            s.backgroundColor = "white";
            s.border = "solid 1px black";
            s.position = "absolute";
            s.height = "18px";
            s.font = "bold 8pt sans-serif";
            s.display = "none";
            s.textAlign = "left";
            s.overflow = "hidden";
            util.attachDOMEvent(this.outerDiv, "mousedown", this._SelectorMouseDown);
            util.attachDOMEvent(this.outerDiv, "mouseover", this._SelectorMouseOver);
            util.attachDOMEvent(this.outerDiv, "mouseout", this._SelectorMouseOut);
            this.registerEvents();
            this.kbdIcon.src = imgPath + "kbdicon.gif";
            this.kbdIcon.title = "Display visual keyboard";
            this.oskButtonState(false);
            var Lhdiv = util.createElement("div");
            this.oskButton = Lhdiv;
            Lhdiv.onclick = this.toggleOSK;
            Lhdiv.appendChild(this.kbdIcon);
            this.innerDiv.appendChild(Lhdiv);
            this.outerDiv.appendChild(this.innerDiv);
            document.body.appendChild(this.outerDiv);
            this.KeyboardSelector = util.createElement("select");
            s = this.KeyboardSelector.style;
            s.font = "8pt sans-serif";
            s.backgroundColor = "#f3e5de";
            s.border = "solid 1px #7B9EBD";
            s.height = "16px";
            s.margin = "1px 2px 0px 2px";
            s.left = "20px";
            s.top = "0px";
            s.position = "absolute";
            s.maxWidth = "150px";
            util.attachDOMEvent(this.KeyboardSelector, "change", this.SelectKeyboardChange);
            util.attachDOMEvent(this.KeyboardSelector, "blur", this.SelectBlur);
            this.innerDiv.appendChild(this.KeyboardSelector);
            var opt = util.getOption("ui"), dfltKeyboard = "(System keyboard)";
            if (opt && typeof opt == "object") {
              if (typeof opt["position"] == "string" && opt["position"] == "right") {
                this.floatRight = true;
              }
              if (typeof opt["default"] == "string") {
                dfltKeyboard = opt["default"];
              }
            }
            var Lopt = util.createElement("option");
            Lopt.value = "-";
            Lopt.innerHTML = dfltKeyboard;
            this.KeyboardSelector.appendChild(Lopt);
            Lopt = null;
            this.initialized = true;
            this.updateKeyboardList();
          };
          this._UnloadUserInterface = () => {
            this.KeyboardSelector = this.innerDiv = this.outerDiv = this.kbdIcon = null;
          };
          this.updateKeyboardList = () => {
            if (this.updateList) {
              if (!this.initialized) {
                this.initialize();
              }
              const opts = this.KeyboardSelector.getElementsByTagName("OPTION");
              for (let i = opts.length; i > 1; i--) {
                this.KeyboardSelector.removeChild(opts[i - 1]);
              }
              var Lkbds = keymanweb.getKeyboards();
              for (let Ln = 0; Ln < Lkbds.length; Ln++) {
                let Lopt = util.createElement("option");
                Lopt.value = Lkbds[Ln].InternalName + ":" + Lkbds[Ln].LanguageCode;
                Lopt.innerHTML = Lkbds[Ln].Name.replace(/\s?keyboard/i, "");
                if (Lkbds[Ln].LanguageName) {
                  var lg = Lkbds[Ln].LanguageName;
                  lg = lg.split(",")[0];
                  if (Lkbds[Ln].Name.search(lg) == -1) {
                    Lopt.innerHTML = lg + " (" + Lopt.innerHTML + ")";
                  }
                }
                this.KeyboardSelector.appendChild(Lopt);
                Lopt = null;
              }
            }
            this.updateList = false;
            const sk = keymanweb.getSavedKeyboard().split(":");
            if (sk.length < 2) {
              sk[1] = "";
            }
            this.updateMenu(sk[0], sk[1]);
            if (keymanweb.getLastActiveElement()) {
              this.HideInterface();
              this.ShowInterface();
            }
          };
          this.updateMenu = (kbd, lg) => {
            var i = 0;
            if (!this.initialized) {
              return;
            }
            var match = kbd;
            if (lg != "") {
              match += ":" + lg;
            }
            if (kbd == "") {
              this.KeyboardSelector.selectedIndex = 0;
            } else {
              const opt = this.KeyboardSelector.getElementsByTagName("option");
              for (i = 0; i < opt.length; i++) {
                let t = opt[i].value;
                if (lg == "") {
                  t = t.split(":")[0];
                }
                if (t == match) {
                  this.KeyboardSelector.selectedIndex = i;
                  break;
                }
              }
            }
          };
          this.oskButtonState = (oskEnabled) => {
            var s = this.kbdIcon.style;
            s.width = "24px";
            s.height = "13px";
            s.top = "1px";
            s.verticalAlign = "bottom";
            s.padding = "2px 2px 1px 2px";
            s.position = "absolute";
            s.border = oskEnabled ? "inset 1px #808080" : "none";
            s.background = oskEnabled ? "#f7e7de" : "white";
            s.display = "block";
            if (this.initialized) {
              this.oskButton.style.display = "block";
            }
          };
          this._SelectorMouseDown = (e) => {
            if (keymanweb.activatingUI) {
              keymanweb.activatingUI(1);
            }
          };
          this._SelectorMouseOver = (e) => {
            if (keymanweb.activatingUI) {
              keymanweb.activatingUI(1);
            }
          };
          this._SelectorMouseOut = (e) => {
            if (keymanweb.activatingUI) {
              keymanweb.activatingUI(0);
            }
          };
          this.SelectKeyboardChange = (e) => {
            keymanweb.activatingUI(true);
            if (this.KeyboardSelector.value != "-") {
              var i = this.KeyboardSelector.selectedIndex;
              var t = this.KeyboardSelector.options[i].value.split(":");
              keymanweb.setActiveKeyboard(t[0], t[1]);
            } else {
              keymanweb.setActiveKeyboard("");
            }
            keymanweb.focusLastActiveElement();
            keymanweb.activatingUI(false);
            this.selecting = true;
          };
          this.SelectBlur = (e) => {
            if (!this.selecting) {
              keymanweb.focusLastActiveElement();
            }
            this.selecting = false;
          };
          this.ShowInterface = (Px, Py) => {
            if (!this.initialized)
              return;
            var Ls = this.outerDiv.style;
            if (Px && Py) {
              Ls.left = Px + "px";
              Ls.top = Py + "px";
            }
            Ls.display = "block";
            this.kbdIcon.style.left = this.KeyboardSelector.offsetWidth + 24 + "px";
            this.addButtonOSK();
            this.updateMenu(keymanweb.getActiveKeyboard(), keymanweb.getActiveLanguage());
          };
          this.HideInterface = () => {
            if (!this.initialized) {
              return;
            }
            this.outerDiv.style.display = "none";
          };
          this.addButtonOSK = () => {
            if (this.oskButton != null) {
              if (keymanweb.isCJK() || this.KeyboardSelector.selectedIndex == 0) {
                this.oskButton.style.display = "none";
                this.outerDiv.style.width = this.KeyboardSelector.offsetWidth + 30 + "px";
              } else {
                this.oskButton.style.display = "block";
                let osk = keymanweb.osk;
                if (osk) {
                  this.oskButtonState(osk.isEnabled());
                } else {
                  this.oskButtonState(false);
                }
                this.outerDiv.style.width = this.KeyboardSelector.offsetWidth + 56 + "px";
              }
            }
          };
          this._Resize = (e) => {
            if (this.outerDiv.style.display == "block") {
              var elem = keymanweb.getLastActiveElement();
              if (this.floatRight) {
                this.ShowInterface(util.getAbsoluteX(elem) + elem.offsetWidth + 1, util.getAbsoluteY(elem) + 1);
              } else {
                this.ShowInterface(util.getAbsoluteX(elem) + 1, util.getAbsoluteY(elem) + elem.offsetHeight + 1);
              }
            }
            return true;
          };
        }
        /**
         * UI removal - resource cleanup
         */
        shutdown() {
          var root = this.outerDiv;
          if (root) {
            root.parentNode.removeChild(root);
          }
          this._UnloadUserInterface();
          if (window.removeEventListener) {
            window.removeEventListener("resize", this._Resize, false);
          }
        }
        /**
         * Register all keymanweb and OSK events only after keymanweb is fully initialized
         *
         **/
        registerEvents() {
          keymanweb.addEventListener("keyboardregistered", (p) => {
            this.updateList = true;
            if (this.updateTimer) {
              clearTimeout(this.updateTimer);
            }
            this.updateTimer = window.setTimeout(this.updateKeyboardList, 200);
          });
          keymanweb.addEventListener("keyboardloaded", (p) => {
            const sk = keymanweb.getSavedKeyboard().split(":");
            if (sk.length > 1) {
              this.updateMenu(sk[0], sk[1]);
            }
          });
          keymanweb.addEventListener("keyboardchange", (p) => {
            this.updateMenu(p.internalName, p.languageCode);
            this.addButtonOSK();
          });
          let osk = keymanweb.osk;
          if (!osk) {
            return;
          }
          osk.addEventListener("show", (oskPosition) => {
            this.addButtonOSK();
            return oskPosition;
          });
          osk.addEventListener("hide", (hiddenByUser) => {
            if (this.initialized) {
              this.oskButtonState(false);
            }
          });
        }
      };
      __name(_UIFloat, "UIFloat");
      let UIFloat = _UIFloat;
      const ui = keymanweb.ui = new UIFloat();
      keymanweb.addEventListener("controlfocused", (params) => {
        if (params.activeControl == null || params.activeControl["_kmwAttachment"]) {
          if (ui.floatRight) {
            ui.ShowInterface(util.getAbsoluteX(params.target) + params.target.offsetWidth + 1, util.getAbsoluteY(params.target) + 1);
          } else {
            ui.ShowInterface(util.getAbsoluteX(params.target), util.getAbsoluteY(params.target) - parseInt(util.getStyleValue(ui.outerDiv, "height"), 10) - 2);
          }
        }
        return true;
      });
      keymanweb.addEventListener("controlblurred", (params) => {
        if (!params.event) {
          return true;
        }
        if (!params.isActivating) {
          ui.HideInterface();
        }
        return true;
      });
      if (window.addEventListener) {
        window.addEventListener("resize", ui._Resize, false);
      }
      ui.initialize();
    } catch (err) {
    }
  }
})();
//# sourceMappingURL=kmwuifloat.js.map
