(() => {
  var __defProp = Object.defineProperty;
  var __name = (target, value) => __defProp(target, "name", { value, configurable: true });

  // ../../../build/app/ui/obj/kmwuitoolbar.js
  var _a;
  var keymanweb = window.keyman;
  if (!keymanweb) {
    throw new Error("`keyman` global is missing; Keyman Engine for Web script has not been loaded");
  } else if (!((_a = keymanweb.ui) === null || _a === void 0 ? void 0 : _a.name)) {
    try {
      const util = keymanweb.util;
      if (util.isTouchDevice()) {
        throw "";
      }
      const _ToolbarUI = class _ToolbarUI {
        constructor() {
          this.init = false;
          this.toolbarNode = null;
          this.browseMapNode = null;
          this.keyboardsButtonNode = null;
          this.languageButtonsNode = null;
          this.offButtonNode = null;
          this.offBarNode = null;
          this.oskButtonNode = null;
          this.oskBarNode = null;
          this.selectorNode = null;
          this.regionLanguageListNodes = {};
          this.regionsNode = null;
          this.regionNodes = null;
          this.langKeyboardNodes = {};
          this.langKeyboardListNodes = {};
          this.selectedRegion = "as";
          this.listedKeyboards = [];
          this.catchAllRegion = "un";
          this.keyboardListPriority = 0;
          this.maxListedKeyboards = 1;
          this.lastActiveControl = null;
          this.selectedKeyboard = null;
          this.selectedLanguage = "";
          this.helpOffsetX = 0;
          this.helpOffsetY = 0;
          this.keyboardsForLangPopup = null;
          this.lastSelectedKeyboard = null;
          this.languages = {};
          this.updateMap = false;
          this.startTimer = 0;
          this.lgText = "";
          this.name = "toolbar";
          this.ToolBar_Text = {
            Keyboards: "Languages",
            OffTitle: "Turn off KeymanWeb keyboards",
            Off: "Off",
            ShowOSK: "Show On Screen Keyboard",
            LanguageSelector: "Select language",
            SelectKeyboardPre: "Select ",
            SelectKeyboardSuf: "keyboard",
            AltKeyboardsPre: "Alternate keyboards for ",
            AltKeyboardsSuf: "",
            ca: "Central America",
            sa: "South America",
            na: "Americas",
            eu: "Europe",
            af: "Africa",
            un: "Undetermined",
            as: "Asia",
            oc: "Oceania"
          };
          this.addKeyboardsToMap = () => {
            if (this.updateMap) {
              this.updateMap = false;
            } else {
              return;
            }
            this.regionLanguageListNodes = {};
            let Keyboards = keymanweb.getKeyboards();
            Keyboards.sort(this.sortKeyboards);
            let n = 0;
            for (n = this.regionsNode.children.length; n > 0; n--) {
              if (this.regionsNode.children[n - 1].className == "kmw_selector_region") {
                this.regionsNode.removeChild(this.regionsNode.childNodes[n - 1]);
              }
            }
            for (let i in this.regions) {
              this.regionLanguageListNodes[i] = this.createNode("div", null, "kmw_selector_region");
              let colNode = this.createNode("div", null, "kmw_keyboard_col");
              var max = 0, count = 0, languageCode = "";
              for (let j = 0; j < Keyboards.length; j++) {
                var kbdRegion = Keyboards[j].RegionCode;
                if (!this.regions[kbdRegion]) {
                  if (i != this.catchAllRegion) {
                    continue;
                  }
                } else if (kbdRegion != i) {
                  continue;
                }
                var bcpSubtags = keymanweb.util.getLanguageCodes(Keyboards[j].LanguageCode);
                if (bcpSubtags[0] == languageCode) {
                  continue;
                }
                languageCode = bcpSubtags[0];
                max++;
              }
              max = Number(((max + 3) / 4).toFixed(0));
              languageCode = "";
              for (let j = 0; j < Keyboards.length; j++) {
                const kbdRegion2 = Keyboards[j].RegionCode;
                if (!this.regions[kbdRegion2]) {
                  if (i != this.catchAllRegion) {
                    continue;
                  }
                } else if (kbdRegion2 != i) {
                  continue;
                }
                var bcpSubtags = keymanweb.util.getLanguageCodes(Keyboards[j].LanguageCode);
                if (bcpSubtags[0] == languageCode) {
                  var x = this.languages[languageCode].keyboards;
                  if (x.push) {
                    x.push(Keyboards[j]);
                  } else {
                    this.languages[languageCode].keyboards = x.concat(Keyboards[j]);
                  }
                  continue;
                }
                languageCode = bcpSubtags[0];
                this.languages[languageCode] = {
                  id: Keyboards[j].LanguageCode,
                  name: Keyboards[j].LanguageName,
                  keyboards: [Keyboards[j]]
                };
                if (count % max == 0 && count > 0) {
                  this.regionLanguageListNodes[i].appendChild(colNode);
                  colNode = this.createNode("div", null, count / max == 3 ? "kmw_keyboard_col_right" : "kmw_keyboard_col");
                }
                count++;
                const langNode = this.createNode("div", null, "kmw_language");
                const aNode = this.createNode("a", null, null, Keyboards[j].LanguageName);
                aNode.href = "#";
                aNode.onclick = /* @__PURE__ */ ((lang) => {
                  return (event) => this.selectLanguage(event, lang);
                })(this.languages[languageCode]);
                langNode.appendChild(aNode);
                colNode.appendChild(langNode);
                n++;
              }
              this.regionLanguageListNodes[i].appendChild(colNode);
              this.regionLanguageListNodes[i].appendChild(this.createNode("div", null, "kmw_clear"));
              this.regionsNode.appendChild(this.regionLanguageListNodes[i]);
            }
            this.loadCookie();
            this.selectRegion(null, this.selectedRegion);
            this.enableControls();
            if (this.lastSelectedKeyboard) {
              this.changeKeyboardEvent(this.lastSelectedKeyboard);
            }
            keymanweb.focusLastActiveElement();
          };
          this.sortKeyboards = function(a, b) {
            if (a.RegionCode < b.RegionCode) {
              return -2;
            }
            if (a.RegionCode > b.RegionCode) {
              return 2;
            }
            if (a.LanguageName < b.LanguageName) {
              return -1;
            }
            if (a.LanguageName > b.LanguageName) {
              return 1;
            }
            return 0;
          };
          this.registerKeyboard = () => {
            this.updateMap = true;
            if (this.startTimer) {
              clearTimeout(this.startTimer);
            }
            this.startTimer = window.setTimeout(this.addKeyboardsToMap, 0);
          };
          this.hideKeyboardsForLanguage = (event) => {
            var e = this.keyboardsForLangPopup;
            if (e) {
              e.style.display = "none";
            }
            this.CancelPopupDismissal(this.hideKeyboardsForLanguage);
            return this.eventCapture(event);
          };
          this.showKeyboardsForLanguage = (event, lang) => {
            this.hideKeyboardsPopup(event);
            const e = this.langKeyboardListNodes[lang.id];
            if (e) {
              if (e.style.display == "block") {
                return this.hideKeyboardsForLanguage(event);
              }
              e.style.display = "block";
              this.keyboardsForLangPopup = e;
              this.SetupPopupDismissal(e, this.hideKeyboardsForLanguage);
            }
            return this.eventCapture(event);
          };
          this.showOSK = (event) => {
            let osk = keymanweb.osk;
            if (!osk) {
              return false;
            }
            keymanweb.activatingUI(true);
            if (osk && keymanweb.getActiveKeyboard() != "") {
              if (osk.isEnabled()) {
                osk.hide();
              } else {
                osk.show(true);
              }
            }
            this.setLastFocus();
            keymanweb.activatingUI(false);
            return this.eventCapture(event);
          };
          this.offButtonClickEvent = (event) => {
            if (this.toolbarNode.className != "kmw_controls_disabled") {
              this.hideKeyboardsForLanguage(null);
              if (this.selectedLanguage) {
                var found = this.findListedKeyboard(this.selectedLanguage);
                if (found != null) {
                  this.listedKeyboards[found].buttonNode.className = "kmw_button";
                }
              }
              this.selectedKeyboard = null;
              this.selectedLanguage = null;
              this.offButtonNode.className = "kmw_button_selected";
            }
            this.setLastFocus();
            keymanweb.setActiveKeyboard("", "");
            this.saveCookie();
            this.enableControls();
            return this.eventCapture(event);
          };
          this.eventCapture = (event) => {
            if (!event) {
              event = window.event;
            }
            if (window.event) {
              window.event.returnValue = false;
            }
            if (event) {
              event.cancelBubble = true;
            }
            return false;
          };
          this.selectRegion = (event, region) => {
            let e = this.browseMapNode;
            if (!e) {
              return this.eventCapture(event);
            }
            e.className = "kmw_browsemap_" + region;
            if (typeof this.regionLanguageListNodes[region] == "undefined") {
              this.updateMap = true;
              this.addKeyboardsToMap();
            }
            this.regionLanguageListNodes[region].style.display = "block";
            this.regionNodes[region].className = "selected";
            if (this.selectedRegion != null && this.selectedRegion != region) {
              this.regionLanguageListNodes[this.selectedRegion].style.display = "none";
              this.regionNodes[this.selectedRegion].className = "";
            }
            this.selectedRegion = region;
            return this.eventCapture(event);
          };
          this.unhoverRegion = (event, region) => {
            this.browseMapNode.className = this.selectedRegion == null ? "" : "kmw_browsemap_" + this.selectedRegion;
            this.regionNodes[region].className = this.selectedRegion == region ? "selected" : "";
            return this.eventCapture(event);
          };
          this.hoverRegion = (event, region) => {
            this.browseMapNode.className = "kmw_browsemap_" + region + "_sel";
            this.regionNodes[region].className = "hover";
            return this.eventCapture(event);
          };
          this.focusControlEvent = (params) => {
            if (!this.init) {
              return true;
            }
            let t = params.target;
            if (t.tagName.toLowerCase() == "textarea" || t.tagName.toLowerCase() == "input" && t.type.toLowerCase() == "text") {
              this.lastActiveControl = t;
              if (this.pluck(t, "kmw_disable")) {
                if (this.toolbarNode.className != "kmw_controls_disabled") {
                  this.toolbarNode.className = "kmw_controls_disabled";
                }
              } else {
                if (this.selectedKeyboard != null) {
                  if (keymanweb.isCJK()) {
                    this.oskButtonNode.style.display = this.oskBarNode.style.display = "none";
                  } else {
                    let osk = keymanweb.osk;
                    this.oskButtonNode.className = osk && osk.isEnabled() ? "kmw_button_selected" : "kmw_button";
                  }
                }
                if (this.toolbarNode.className != "") {
                  this.toolbarNode.className = "";
                }
                let offsetX, offsetY;
                if (t["KMW_HelpOffsetX"]) {
                  offsetX = t["KMW_HelpOffsetX"];
                } else {
                  offsetX = 64;
                }
                if (t["KMW_HelpOffsetY"]) {
                  offsetY = t["KMW_HelpOffsetY"];
                } else {
                  offsetY = 0;
                }
                this.helpOffsetX = util.getAbsoluteX(t) + offsetX;
                this.helpOffsetY = util.getAbsoluteY(t) + t.offsetHeight + offsetY;
              }
            }
            return true;
          };
          this.blurControlEvent = () => {
            if (!this.init) {
              return true;
            }
            if (this.oskButtonNode.style.display != "none") {
              this.oskButtonNode.className = "kmw_button_disabled";
            }
            return true;
          };
          this.changeKeyboardEvent = (p) => {
            this.lastSelectedKeyboard = null;
            let kbName = p.internalName, lgName = keymanweb.util.getLanguageCodes(p.languageCode)[0];
            if (lgName != "" && kbName != "") {
              let lg = this.languages[lgName];
              if (lg != null) {
                for (let j = 0; j < lg.keyboards.length; j++) {
                  if (lg.keyboards[j].InternalName == kbName) {
                    this.selectKeyboard(null, lg, lg.keyboards[j], false);
                    return true;
                  }
                }
              }
              this.lastSelectedKeyboard = Object.assign({}, p);
            }
            return true;
          };
          this.onShowOSK = (oskPosition) => {
            if (this.init) {
              this.oskButtonNode.className = "kmw_button_selected";
            }
            return oskPosition;
          };
          this.onHideOSK = (p) => {
            if (this.init && p.HiddenByUser) {
              this.oskButtonNode.className = "kmw_button";
            }
          };
          this.showKeyboardsPopup = (event) => {
            this.addKeyboardsToMap();
            if (this.toolbarNode.className == "kmw_controls_disabled") {
              return this.eventCapture(event);
            }
            this.hideKeyboardsForLanguage(null);
            if (this.selectorNode.className == "kmw_over") {
              return this.hideKeyboardsPopup(event);
            }
            this.selectorNode.className = "kmw_over";
            this.keyboardsButtonNode.className = "kmw_button_selected";
            this.SetupPopupDismissal(this.selectorNode, this.hideKeyboardsPopup);
            return this.eventCapture(event);
          };
          this.hideKeyboardsPopup = (event) => {
            this.selectorNode.className = "";
            this.keyboardsButtonNode.className = "kmw_button";
            this.CancelPopupDismissal(this.hideKeyboardsPopup);
            return this.eventCapture(event);
          };
          this.hideAllPopups = (event) => {
            var e = this.keyboardsForLangPopup;
            if ((!e || e.style.display == "none") && this.selectorNode.className == "") {
              return true;
            }
            this.hideKeyboardsPopup(event);
            this.hideKeyboardsForLanguage(event);
            return this.eventCapture(event);
          };
          this.dismissalCallback = null;
          this.popupElement = null;
          this.lastDismissalCallback = null;
          this.PopupDismissal = (event) => {
            let t = event && event.target || window.event && window.event.srcElement;
            if (t) {
              while (t.parentElement) {
                if (t == this.popupElement) {
                  return null;
                }
                t = t.parentElement;
              }
            }
            if (t.nodeName == "#document") {
              this.hideAllPopups(event);
            }
            return this.dismissalCallback;
          };
        }
        /**
         * Create some of the controls but don't insert them into the document yet
         * This does not need or want to prevent loss of focus, so uses document.createElement
         * rather than util.createElement.
         *
         * @param       {string}  tag
         * @param       {?string=}  id
         * @param       {?string=}  className
         * @param       {string=}  innerHTML
         * @return      {Node|null}
         */
        createNode(tag, id, className, innerHTML) {
          const node = document.createElement(tag);
          if (id) {
            node.id = id;
          }
          if (className) {
            node.className = className;
          }
          if (innerHTML) {
            node.innerHTML = innerHTML;
          }
          if (tag == "a" || tag == "area" || tag == "map") {
            node.ondragstart = () => false;
          }
          return node;
        }
        /**
         * Initialize toolbar UI
         */
        initialize() {
          if (!keymanweb.initialized || this.init) {
            return;
          }
          let e = document.getElementById("KeymanWebControl");
          if (!e) {
            if (document.body == null) {
              return;
            } else {
              e = document.createElement("div");
              e.id = "KeymanWebControl";
              document.body.insertBefore(e, document.body.firstChild);
              this._insertedElem = e;
            }
          }
          e.style.visibility = "hidden";
          e.style.maxHeight = "35px";
          this.init = true;
          if (util.isTouchDevice()) {
            return;
          }
          this.regions = {};
          this.regions["na"] = { t: this.ToolBar_Text["na"], m: "0,3,0,37,24,32,35,37,43,47,49,52,65,54,68,57,71,56,73,59,75,60,93,61,93,57,103,49,118,41,126,41,136,23,148,17,156,14,164,5,164,0,57,0,35,5,25,9,5,8,49,52,65,54,68,57,71,56,73,59,75,60,93,61,94,58,97,58,101,59,107,60,114,64,115,68,114,77,104,74,98,75,96,78,95,82,90,81,85,80,82,76,78,74,74,73,65,68,57,61,82,82,95,82,96,78,98,75,104,74,114,77,120,79,124,83,126,87,141,90,142,97,138,103,135,113,127,116,123,124,115,131,112,132,109,138,117,139,140,141,141,146,134,148,114,145,109,148,100,148,91,143,91,130,96,111,89,102,83,95,77,89" }, this.regions["eu"] = { t: this.ToolBar_Text["eu"], m: "145,29,146,19,158,14,171,6,187,2,206,1,217,4,227,11,231,16,231,33,227,34,225,35,225,37,227,39,228,44,228,47,227,48,223,46,218,44,215,43,208,43,203,45,202,48,205,52,201,52,195,49,189,50,187,48,177,48,175,49,166,50,147,33" }, this.regions["af"] = { t: this.ToolBar_Text["af"], m: "150,58,158,50,166,50,175,49,177,48,187,48,189,50,195,49,201,52,205,52,207,53,221,75,229,75,231,77,231,85,227,92,232,101,237,106,237,112,227,115,222,118,206,125,199,127,193,127,185,111,183,104,180,87,168,89,153,85,143,71,147,60" }, this.regions["as"] = { t: this.ToolBar_Text["as"], m: "219,1,221,6,228,12,231,16,231,33,227,34,225,35,225,37,227,39,229,45,232,48,239,48,240,49,239,53,242,60,243,65,249,70,252,81,259,87,271,87,278,95,289,100,303,101,311,98,320,98,323,98,323,84,311,81,308,73,307,65,317,57,330,50,334,44,348,36,364,38,375,34,375,8,355,8,336,5,292,1,285,0,219,0" }, this.regions["oc"] = { t: this.ToolBar_Text["oc"], m: "288,117,289,107,303,101,311,98,323,98,323,84,333,77,344,73,362,80,369,88,375,96,375,141,352,143,323,142,316,136,310,130,291,130" };
          this.regions["un"] = { t: this.ToolBar_Text["un"], m: "205,52,202,48,203,45,208,43,215,43,218,44,223,46,227,48,232,48,239,48,240,49,239,53,242,60,243,65,237,76,231,77,229,75,221,75,207,53" }, this.toolbarNode = this.createNode("div", "kmw_controls");
          this.toolbarNode.style.display = "block";
          util.linkStyleSheet(util.getOption("resources") + "ui/toolbar/kmwuitoolbar.css");
          const tbNode = this.createNode("a", "kmw_controls_start", null, " ");
          tbNode.href = "https://keyman.com/developer/keymanweb/";
          tbNode.target = "_blank";
          this.toolbarNode.appendChild(tbNode);
          this.keyboardsButtonNode = this.createNode("div", "kmw_btn_keyboards", "kmw_button");
          this.keyboardsButtonNode.title = this.ToolBar_Text.LanguageSelector;
          let aNode = this.createNode("a", null, "kmw_button_a");
          aNode.href = "#";
          aNode.onclick = this.showKeyboardsPopup;
          aNode.appendChild(this.createNode("div", "kmw_img_keyboards", "kmw_img"));
          aNode.appendChild(this.createNode("div", null, "kmw_a", this.ToolBar_Text.Keyboards));
          aNode.appendChild(this.createNode("div", null, "kmw_drop"));
          this.keyboardsButtonNode.appendChild(aNode);
          this.selectorNode = this.createNode("div", "kmw_selector");
          this.regionsNode = this.createNode("div", "kmw_selector_regions");
          this.browseMapNode = this.createNode("div", "kmw_browsemap");
          const imgNode = this.createNode("img", "kmw_region_browsemap");
          imgNode.src = util.getOption("resources") + "ui/toolbar/blank.gif";
          imgNode.useMap = "#kmw_worldgrey16";
          this.browseMapNode.appendChild(imgNode);
          const mapNode = this.createNode("map", "kmw_worldgrey16");
          mapNode.name = "kmw_worldgrey16";
          for (let i in this.regions) {
            const areaNode2 = this.createNode("area");
            areaNode2.shape = "poly";
            areaNode2.alt = "";
            areaNode2.href = "#";
            areaNode2.title = this.regions[i].t;
            areaNode2["hidefocus"] = "true";
            areaNode2.onclick = /* @__PURE__ */ ((i2) => {
              return (event) => this.selectRegion(event, i2);
            })(i);
            areaNode2.onmouseover = /* @__PURE__ */ ((i2) => {
              return (event) => this.hoverRegion(event, i2);
            })(i);
            areaNode2.onmouseout = /* @__PURE__ */ ((i2) => {
              return (event) => this.unhoverRegion(event, i2);
            })(i);
            areaNode2.coords = this.regions[i].m;
            mapNode.appendChild(areaNode2);
          }
          const areaNode = this.createNode("area");
          areaNode.shape = "default";
          areaNode.noHref = true;
          areaNode.alt = "";
          areaNode.onclick = this.eventCapture;
          mapNode.appendChild(areaNode);
          this.browseMapNode.appendChild(mapNode);
          this.regionsNode.appendChild(this.browseMapNode);
          this.regionNodes = {};
          const listNode = this.createNode("ul");
          for (let i in this.regions) {
            const itemNode = this.createNode("li");
            this.regionNodes[i] = this.createNode("a", null, null, this.regions[i].t);
            this.regionNodes[i].href = "#";
            this.regionNodes[i].onclick = /* @__PURE__ */ ((i2) => {
              return (event) => this.selectRegion(event, i2);
            })(i);
            this.regionNodes[i].onmouseover = /* @__PURE__ */ ((i2) => {
              return (event) => this.hoverRegion(event, i2);
            })(i);
            this.regionNodes[i].onmouseout = /* @__PURE__ */ ((i2) => {
              return (event) => this.unhoverRegion(event, i2);
            })(i);
            itemNode.appendChild(this.regionNodes[i]);
            listNode.appendChild(itemNode);
          }
          this.regionsNode.appendChild(listNode);
          this.selectorNode.appendChild(this.regionsNode);
          this.keyboardsButtonNode.appendChild(this.selectorNode);
          this.toolbarNode.appendChild(this.keyboardsButtonNode);
          this.toolbarNode.appendChild(this.offBarNode = this.createNode("div", "kmw_bar_off", "kmw_bar"));
          this.offButtonNode = this.createNode("div", "kmw_btn_off", "kmw_button_selected");
          aNode = this.createNode("a", null, "kmw_button_a");
          aNode.href = "#";
          aNode.onclick = this.offButtonClickEvent;
          aNode.title = this.ToolBar_Text.OffTitle;
          aNode.appendChild(this.createNode("div", "kmw_img_off", "kmw_img"));
          aNode.appendChild(this.createNode("div", null, "kmw_a", this.ToolBar_Text.Off));
          this.offButtonNode.appendChild(aNode);
          this.toolbarNode.appendChild(this.offButtonNode);
          this.toolbarNode.appendChild(this.languageButtonsNode = this.createNode("div", "kmw_control_keyboards", "kmw_button"));
          this.toolbarNode.appendChild(this.oskBarNode = this.createNode("div", "kmw_bar_osk", "kmw_bar"));
          this.oskButtonNode = this.createNode("div", "kmw_btn_osk", "kmw_button");
          aNode = this.createNode("a", null, "kmw_button_a");
          aNode.href = "#";
          aNode.onclick = this.showOSK;
          aNode.onmousedown = function() {
            keymanweb.activatingUI(true);
          };
          aNode.title = this.ToolBar_Text.ShowOSK;
          aNode.appendChild(this.createNode("div", "kmw_img_osk", "kmw_img"));
          this.oskButtonNode.appendChild(aNode);
          this.toolbarNode.appendChild(this.oskButtonNode);
          this.toolbarNode.appendChild(this.createNode("div", "kmw_controls_end", null, " "));
          const img = this.createNode("div");
          img.id = "kmw_map_preload";
          this.toolbarNode.appendChild(img);
          this.toolbarNode.appendChild(this.createNode("br", null, "kmw_clear"));
          e.appendChild(this.toolbarNode);
          this.updateMap = true;
          if (this.startTimer) {
            clearTimeout(this.startTimer);
          }
          this.startTimer = window.setTimeout(this.addKeyboardsToMap, 0);
          util.attachDOMEvent(document.body, "click", this.hideAllPopups, false);
          this.selectedRegion = "eu";
          this.registerEvents();
          keymanweb.focusLastActiveElement();
        }
        shutdown() {
          let root = this.toolbarNode;
          if (root) {
            root.parentNode.removeChild(root);
          }
          root = this._insertedElem;
          if (root) {
            root.parentNode.removeChild(root);
          }
        }
        /* KeymanWeb Interfaces */
        /**
         * Function     findListedKeyboard
         * Scope        Private
         * @param       {Object}  lang
         * @return      {?number}
         * Description  Test if a keyboard is still shown on the toolbar.  Returns index of keyboard in listedKeyboards or null if not found
         */
        findListedKeyboard(lang) {
          if (typeof lang != "string") {
            lang = lang.id;
          }
          for (let i = 0; i < this.listedKeyboards.length; i++) {
            if (this.listedKeyboards[i].lang.id == lang) {
              return i;
            }
          }
          return null;
        }
        /**
         * Add a keyboard to the list of keyboards available for a language
         *
         * @param       {Object}  lang
         * @param       {Object}  kbd
         **/
        addKeyboardToList(lang, kbd) {
          let found = this.findListedKeyboard(lang);
          if (found == null) {
            if (this.listedKeyboards.length >= this.maxListedKeyboards) {
              let oldestPriority = 2147483647, oldestFound = null;
              for (let i = 0; i < this.listedKeyboards.length; i++) {
                if (this.listedKeyboards[i].priority < oldestPriority) {
                  oldestFound = i;
                  oldestPriority = this.listedKeyboards[i].priority;
                }
              }
              if (oldestFound != null) {
                let rk = this.listedKeyboards[oldestFound];
                this.langKeyboardListNodes[rk.lang.id] = null;
                this.langKeyboardNodes[rk.lang.id] = null;
                this.languageButtonsNode.removeChild(rk.buttonNode);
                if (oldestFound == 0) {
                  this.listedKeyboards = this.listedKeyboards.slice(oldestFound + 1);
                } else if (oldestFound == this.listedKeyboards.length - 1) {
                  this.listedKeyboards = this.listedKeyboards.slice(0, oldestFound);
                } else {
                  this.listedKeyboards = this.listedKeyboards.slice(0, oldestFound).concat(this.listedKeyboards.slice(oldestFound + 1));
                }
              }
            }
            let buttonNode = this.createNode("div", null, "kmw_button");
            let aNode = this.createNode("a", null, "kmw_button_a" + (lang.keyboards.length > 1 ? " kmw_norightgap" : ""));
            aNode.href = "#";
            let p1 = this.ToolBar_Text["SelectKeyboardPre"] + kbd.Name;
            let p2 = this.ToolBar_Text["SelectKeyboardSuf"];
            if (p1.toLowerCase().indexOf(p2.toLowerCase()) < 0) {
              p1 = p1 + " " + p2;
            }
            aNode.title = p1;
            aNode.onclick = (event) => this.selectLanguage(event, lang);
            aNode.appendChild(this.createNode("div", "kmw_img_kbd", "kmw_img"));
            this.lgText = this.truncate(lang.name, 28);
            aNode.appendChild(this.createNode("div", null, "kmw_a", this.lgText));
            buttonNode.appendChild(aNode);
            let thisANode = aNode;
            if (lang.keyboards.length > 1) {
              aNode = this.createNode("a", null, "kmw_button_a kmw_noleftgap");
              aNode.href = "#";
              aNode.title = this.ToolBar_Text["AltKeyboardsPre"] + lang.name + this.ToolBar_Text["AltKeyboardsSuf"];
              aNode.onclick = (event) => this.showKeyboardsForLanguage(event, lang);
              let divNode = this.createNode("div", null, "kmw_a");
              let kbdText2 = this.truncate(kbd.Name.replace(/\s?keyboard/i, ""), 40 - this.lgText.length);
              divNode.appendChild(this.langKeyboardNodes[lang.id] = this.createNode("span", null, "kmw_kbd", kbdText2));
              aNode.appendChild(divNode);
              aNode.appendChild(this.createNode("div", null, "kmw_drop"));
              buttonNode.appendChild(aNode);
              this.langKeyboardListNodes[lang.id] = this.createNode("ul", null, "kmw_selector_kbd");
              this.langKeyboardListNodes[lang.id].style.display = "none";
              for (let n in lang.keyboards) {
                let itemNode = this.createNode("li");
                kbdText2 = lang.keyboards[n].Name.replace(/\s?keyboard/i, "");
                kbdText2 = kbdText2 + " [" + lang.keyboards[n].LanguageCode + "]";
                aNode = this.createNode("a", null, null, kbdText2);
                aNode.href = "#";
                aNode.title = "";
                aNode.onclick = /* @__PURE__ */ ((lang2, kbd2) => {
                  return (event) => this.selectKeyboard(event, lang2, kbd2, true);
                })(lang, lang.keyboards[n]);
                itemNode.appendChild(aNode);
                this.langKeyboardListNodes[lang.id].appendChild(itemNode);
              }
              buttonNode.appendChild(this.langKeyboardListNodes[lang.id]);
            }
            this.languageButtonsNode.appendChild(buttonNode);
            let thisLang = lang, thisButtonNode = buttonNode;
            this.listedKeyboards.push({ priority: this.keyboardListPriority++, lang: thisLang, keyboard: kbd, buttonNode: thisButtonNode, aNode: thisANode });
          } else {
            this.listedKeyboards[found].priority = this.keyboardListPriority++;
            this.listedKeyboards[found].keyboard = kbd;
            let e = this.langKeyboardNodes[lang.id];
            if (e) {
              var kbdText = kbd.Name.replace(/\s?keyboard/i, "");
              e.innerHTML = this.truncate(kbdText, 40 - this.lgText.length);
            }
            if (this.listedKeyboards[found].aNode) {
              let p1 = this.ToolBar_Text["SelectKeyboardPre"] + kbd.Name;
              let p2 = this.ToolBar_Text["SelectKeyboardSuf"];
              if (p1.toLowerCase().indexOf(p2.toLowerCase()) < 0) {
                p1 = p1 + " " + p2;
              }
              this.listedKeyboards[found].aNode.title = p1;
            }
          }
        }
        /**
         *  Truncate a long name and add an ellipsis
         *
         *  @param  {string}  PName   string that may need to be truncated
         *  @param  {number}  PLen    max non-truncated length
         *  @return {string}          string, truncated with ellipsis if necessary
         *
         **/
        truncate(PName, PLen) {
          if (PName.length <= PLen) {
            return PName;
          }
          return PName.substr(0, PLen - 1) + "\u2026";
        }
        /**
         * Select the language, and either select the keyboard (if unique) or display the list of keyboards
         * available for this language
         *
         * @param       {Object}  event
         * @param       {Object}  lang
         * @return      {boolean}
         **/
        selectLanguage(event, lang) {
          let found = this.findListedKeyboard(lang);
          let kbd = null;
          if (found == null) {
            kbd = lang.keyboards[0];
          } else {
            kbd = this.listedKeyboards[found].keyboard;
          }
          if (!kbd) {
            return false;
          }
          return this.selectKeyboard(event, lang, kbd, true);
        }
        /**
         * Enable a selected keyboard
         *
         * @param       {Object}  event
         * @param       {Object}  lang
         * @param       {Object}  kbd
         * @param       {boolean} updateKeyman
         * @return      {boolean}
         **/
        selectKeyboard(event, lang, kbd, updateKeyman) {
          keymanweb.activatingUI(true);
          if (this.selectedLanguage) {
            let found = this.findListedKeyboard(this.selectedLanguage);
            if (found != null) {
              this.listedKeyboards[found].buttonNode.className = "kmw_button";
            }
          }
          this.offButtonNode.className = "kmw_button";
          this.selectedKeyboard = kbd;
          this.selectedLanguage = kbd.LanguageCode;
          this.addKeyboardToList(lang, kbd);
          if (updateKeyman) {
            keymanweb.setActiveKeyboard(kbd.InternalName, kbd.LanguageCode).then(() => {
              this.setLastFocus();
            });
          }
          this.listedKeyboards[this.findListedKeyboard(lang)].buttonNode.className = "kmw_button_selected";
          this.saveCookie();
          this.enableControls();
          keymanweb.activatingUI(false);
          return this.hideKeyboardsPopup(event) || this.hideKeyboardsForLanguage(event);
        }
        /**
         * Enable all UI controls
         *
         * @return      {boolean}
         **/
        enableControls() {
          let elems = [
            this.offButtonNode,
            this.offBarNode,
            this.oskButtonNode,
            this.oskBarNode
          ];
          let hideOskButton = false;
          if (keymanweb.isCJK(this.selectedKeyboard)) {
            hideOskButton = true;
          } else if (this.selectedKeyboard == null) {
            hideOskButton = elems[2].style.display == "none";
          }
          if (this.selectedKeyboard != null || this.listedKeyboards.length > 0) {
            for (let i = 0; i < elems.length; i++) {
              elems[i].style.display = "";
            }
          } else {
            for (let i = 0; i < elems.length; i++) {
              elems[i].style.display = "none";
            }
          }
          if (hideOskButton) {
            this.oskButtonNode.style.display = this.oskBarNode.style.display = "none";
          } else if (this.selectedKeyboard == null) {
            this.oskButtonNode.className = "kmw_button_disabled";
          }
          this.toolbarNode.parentElement.style.visibility = "visible";
          return true;
        }
        /**
         * Restore the focus to the last focused element
         **/
        setLastFocus() {
          keymanweb.focusLastActiveElement();
        }
        /**
         * Function     pluck
         * Scope        Private
         * @param       {Object}  elem
         * @param       {string}  property
         * @return      {*}
         * Description  Get the value of an element property
         **/
        pluck(elem, property) {
          return elem.getAttribute ? elem.getAttribute(property) || elem[property] : elem[property];
        }
        registerEvents() {
          let osk = keymanweb.osk;
          if (!osk) {
            return;
          }
          osk.addEventListener("show", this.onShowOSK);
          osk.addEventListener("hide", this.onHideOSK);
        }
        /**
         * Function     SetupPopupDismissal
         * Scope        Private
         * @param       {Object}            element
         * @param       {function(Object)}  callback
         * Description  Prepare for callback dismissal
         **/
        SetupPopupDismissal(element, callback) {
          if (this.PopupDismissal == document.onclick) {
            this.CancelPopupDismissal(this.dismissalCallback);
          }
          this.dismissalCallback = callback;
          this.popupElement = element;
          this.lastDismissalCallback = document.onclick;
          document.onclick = this.PopupDismissal;
        }
        /**
         * Function     CancelPopupDismissal
         * Scope        Private
         * @param       {?function(Object)}  callback
         * Description  Cancel callback dismissal
         **/
        CancelPopupDismissal(callback) {
          if (this.PopupDismissal == document.onclick) {
            document.onclick = this.lastDismissalCallback;
            this.lastDismissalCallback = null;
            this.dismissalCallback = null;
            this.popupElement = null;
          }
        }
        /**
         * Load the previous state from the KeymanWeb_Keyboard and KeymanWeb_Toolbar cookies
         **/
        loadCookie() {
          let currentKeyboard = "";
          const kc = util.loadCookie("KeymanWeb_Keyboard");
          if (kc.current != void 0) {
            currentKeyboard = kc.current.split(":")[0];
          }
          const c = util.loadCookie("KeymanWeb_Toolbar");
          if (c.region != void 0) {
            this.selectedRegion = c.region;
          }
          if (c.maxrecent != void 0) {
            for (let i = 0; i < c.maxrecent; i++) {
              if (c[`recent${i}`] != void 0) {
                var r = c[`recent${i}`].split(",");
                if (r.length == 2) {
                  var k = this.languages[r[0]];
                  if (k != null) {
                    for (var j = 0; j < k.keyboards.length; j++) {
                      if (k.keyboards[j].InternalName == r[1]) {
                        this.addKeyboardToList(k, k.keyboards[j]);
                        if (k.keyboards[j].InternalName == currentKeyboard) {
                          this.selectKeyboard(null, k, k.keyboards[j], true);
                          window.focus();
                          this.setLastFocus();
                          break;
                        }
                        break;
                      }
                    }
                  }
                }
              }
            }
          } else {
            let kbName = keymanweb.getActiveKeyboard();
            let lgName = keymanweb.getActiveLanguage();
            if (lgName != "" && kbName != "") {
              var lg = this.languages[lgName];
              if (lg != null) {
                for (var j = 0; j < lg.keyboards.length; j++) {
                  if (lg.keyboards[j].InternalName == kbName) {
                    this.selectKeyboard(null, lg, lg.keyboards[j], true);
                    window.focus();
                    this.setLastFocus();
                  }
                }
              }
            }
          }
        }
        /**
         * Save the current UI state in the KeymanWeb_Toolbar cookie
         **/
        saveCookie() {
          let vs = {
            region: this.selectedRegion,
            maxrecent: this.listedKeyboards.length
          };
          vs.region = this.selectedRegion;
          vs.maxrecent = this.listedKeyboards.length;
          for (var i = 0; i < this.listedKeyboards.length; i++) {
            vs[`recent${i}`] = this.listedKeyboards[i].lang.id + "," + this.listedKeyboards[i].keyboard.InternalName;
          }
          util.saveCookie("KeymanWeb_Toolbar", vs);
        }
      };
      __name(_ToolbarUI, "ToolbarUI");
      let ToolbarUI = _ToolbarUI;
      const ui = keymanweb.ui = new ToolbarUI();
      keymanweb.addEventListener("keyboardregistered", ui.registerKeyboard);
      keymanweb.addEventListener("controlfocused", ui.focusControlEvent);
      keymanweb.addEventListener("controlblurred", ui.blurControlEvent);
      keymanweb.addEventListener("keyboardchange", ui.changeKeyboardEvent);
      ui.initialize();
    } catch (ex) {
    }
  }
})();
//# sourceMappingURL=kmwuitoolbar.js.map
