//
// .keyman-touch-layout JSON format
//
// Follows /common/schemas/keyman-touch-layout/keyman-touch-layout.spec.json for
// reading and
// /common/schemas/keyman-touch-layout/keyman-touch-layout.clean.spec.json for
// writing
//
;
;
;
;
/**
 * Denotes private-use identifiers that should be considered 'reserved'.
 */
export const PRIVATE_USE_IDS = [
    /**
     * Private-use identifiers used by KeymanWeb for the default multitap-into-caps-layer key
     * for keyboards with a caps layer while not defining multitaps on shift.
     */
    'T_*_MT_SHIFT_TO_SHIFT',
    'T_*_MT_SHIFT_TO_CAPS',
    'T_*_MT_SHIFT_TO_DEFAULT'
];
;
/** key type like regular key, framekeys, deadkeys, blank, etc. */
export var TouchLayoutKeySp;
(function (TouchLayoutKeySp) {
    TouchLayoutKeySp[TouchLayoutKeySp["normal"] = 0] = "normal";
    /** A 'frame' key, such as Shift or Enter, which is styled accordingly; uses
     *  the 'KeymanwebOsk' font on KeymanWeb */
    TouchLayoutKeySp[TouchLayoutKeySp["special"] = 1] = "special";
    /** A 'frame' key, such as Shift or Enter, which is styled accordingly and is
     *  highlighted to indicate it is active, such as the shift key on a shift
     *  layer; uses the 'KeymanwebOsk' font on KeymanWeb */
    TouchLayoutKeySp[TouchLayoutKeySp["specialActive"] = 2] = "specialActive";
    /** **KeymanWeb runtime private use:** a variant of `special` with the
     *  keyboard font rather than 'KeymanwebOsk' font */
    TouchLayoutKeySp[TouchLayoutKeySp["customSpecial"] = 3] = "customSpecial";
    /** **KeymanWeb runtime private use:** a  variant of `specialActive` with the
     *  keyboard font rather than 'KeymanwebOsk' font. */
    TouchLayoutKeySp[TouchLayoutKeySp["customSpecialActive"] = 4] = "customSpecialActive";
    /** A styling signal to indicate that the key may have 'deadkey' type
     *  behaviour. */
    TouchLayoutKeySp[TouchLayoutKeySp["deadkey"] = 8] = "deadkey";
    /** A key which is rendered as a blank keycap, blocks any interaction */
    TouchLayoutKeySp[TouchLayoutKeySp["blank"] = 9] = "blank";
    /** Renders the key only as a gap or spacer, blocks any interaction */
    TouchLayoutKeySp[TouchLayoutKeySp["spacer"] = 10] = "spacer";
})(TouchLayoutKeySp || (TouchLayoutKeySp = {}));
;
;
;
//# sourceMappingURL=keyman-touch-layout-file.js.map