import { DependencySections, StrsItem, UsetItem } from './kmx-plus.js';
export declare enum ElemElementFlags {
    none = 0,
    type,
    tertiary_base,
    prebase
}
export declare class ElemElement {
    value?: StrsItem;
    uset?: UsetItem;
    order: number;
    tertiary: number;
    flags: ElemElementFlags;
    isEqual(a: ElemElement): boolean;
}
export declare class ElementString extends Array<ElemElement> {
    /**
     * @param source if a string array, does not get reinterpreted as UnicodeSet. This is used with vars, etc. Or pass `["str"]` for an explicit 1-element elem.
     * If it is a string, will be interpreted per reorder element rules.
     */
    static fromStrings(sections: DependencySections, source: string | string[], order?: string, tertiary?: string, tertiary_base?: string, prebase?: string): ElementString;
    isEqual(a: ElementString): boolean;
    private static parseIntOrZero;
}
//# sourceMappingURL=element-string.d.ts.map