declare const Schemas: {
    kpj: {
        title: string;
        $schema: string;
        type: string;
        properties: {
            KeymanDeveloperProject: {
                properties: {
                    Options: {
                        $ref: string;
                    };
                    Files: {
                        $ref: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
                type: string;
            };
        };
        required: string[];
        additionalProperties: boolean;
        definitions: {
            Options: {
                type: string;
                properties: {
                    BuildPath: {
                        type: string;
                    };
                    SourcePath: {
                        type: string;
                    };
                    CompilerWarningsAsErrors: {
                        type: string;
                        pattern: string;
                    };
                    WarnDeprecatedCode: {
                        type: string;
                        pattern: string;
                    };
                    CheckFilenameConventions: {
                        type: string;
                        pattern: string;
                    };
                    SkipMetadataFiles: {
                        type: string;
                        pattern: string;
                    };
                    ProjectType: {
                        type: string;
                        pattern: string;
                    };
                    Version: {
                        type: string;
                        pattern: string;
                    };
                };
                required: any[];
                additionalProperties: boolean;
            };
            Files: {
                type: string;
                properties: {
                    File: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            File: {
                type: string;
                properties: {
                    ID: {
                        type: string;
                    };
                    Filename: {
                        type: string;
                    };
                    Filepath: {
                        type: string;
                    };
                    FileVersion: {
                        type: string;
                    };
                    FileType: {
                        type: string;
                    };
                    Details: {
                        $ref: string;
                    };
                    ParentFileID: {
                        type: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            FileDetails: {
                type: string;
                properties: {
                    Name: {
                        type: string;
                    };
                    Copyright: {
                        type: string;
                    };
                    Message: {
                        type: string;
                    };
                    Version: {
                        type: string;
                    };
                };
                required: any[];
                additionalProperties: boolean;
            };
        };
    };
    kpj90: {
        title: string;
        $schema: string;
        type: string;
        properties: {
            KeymanDeveloperProject: {
                properties: {
                    Options: {
                        $ref: string;
                    };
                    Files: {
                        $ref: string;
                    };
                    templatepath: {
                        type: string;
                        $comment: string;
                    };
                    stringspath: {
                        type: string;
                        $comment: string;
                    };
                    state: {
                        type: string;
                        $comment: string;
                    };
                    Modules: {
                        oneOf: {
                            type: string;
                        }[];
                        $comment: string;
                    };
                    MRU: {
                        type: string;
                        $comment: string;
                    };
                };
                required: any[];
                additionalProperties: boolean;
                type: string;
            };
        };
        required: string[];
        additionalProperties: boolean;
        definitions: {
            Options: {
                type: string;
                properties: {
                    BuildPath: {
                        type: string;
                    };
                    SourcePath: {
                        type: string;
                    };
                    CompilerWarningsAsErrors: {
                        type: string;
                        pattern: string;
                    };
                    WarnDeprecatedCode: {
                        type: string;
                        pattern: string;
                    };
                    CheckFilenameConventions: {
                        type: string;
                        pattern: string;
                    };
                    ProjectType: {
                        type: string;
                        pattern: string;
                    };
                    Version: {
                        type: string;
                        pattern: string;
                    };
                };
                required: any[];
                additionalProperties: boolean;
            };
            Files: {
                type: string;
                properties: {
                    File: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            File: {
                type: string;
                properties: {
                    ID: {
                        type: string;
                    };
                    Filename: {
                        type: string;
                    };
                    Filepath: {
                        type: string;
                    };
                    FileVersion: {
                        type: string;
                    };
                    FileType: {
                        type: string;
                    };
                    Details: {
                        $ref: string;
                    };
                    ParentFileID: {
                        type: string;
                    };
                    FullPath: {
                        type: string;
                        $comment: string;
                    };
                    IDEState: {
                        type: string;
                        $comment: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            FileDetails: {
                type: string;
                properties: {
                    Name: {
                        type: string;
                    };
                    Copyright: {
                        type: string;
                    };
                    Message: {
                        type: string;
                    };
                    Version: {
                        type: string;
                    };
                    Debug: {
                        type: string;
                        $comment: string;
                    };
                };
                required: any[];
                additionalProperties: boolean;
            };
        };
    };
    kvks: {
        title: string;
        $schema: string;
        type: string;
        properties: {
            visualkeyboard: {
                properties: {
                    header: {
                        $ref: string;
                    };
                    encoding: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                };
                required: string[];
                additionalProperties: boolean;
                type: string;
            };
        };
        required: string[];
        additionalProperties: boolean;
        definitions: {
            "kvk-header": {
                type: string;
                properties: {
                    version: {
                        $ref: string;
                    };
                    kbdname: {
                        type: string;
                    };
                    flags: {
                        $ref: string;
                    };
                    layout: {
                        type: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "kvk-header-flags": {
                type: string;
                properties: {
                    key102: {
                        $ref: string;
                    };
                    displayunderlying: {
                        $ref: string;
                    };
                    usealtgr: {
                        $ref: string;
                    };
                    useunderlying: {
                        $ref: string;
                    };
                };
                additionalProperties: boolean;
            };
            "kvk-encoding": {
                type: string;
                properties: {
                    layer: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                    $: {
                        type: string;
                        properties: {
                            name: {
                                $ref: string;
                            };
                            fontname: {
                                type: string;
                            };
                            fontsize: {
                                type: string;
                            };
                        };
                        required: string[];
                        additionalProperties: boolean;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "kvk-layer": {
                type: string;
                properties: {
                    key: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                    $: {
                        type: string;
                        properties: {
                            shift: {
                                $ref: string;
                            };
                        };
                        required: string[];
                        additionalProperties: boolean;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "kvk-key": {
                type: string;
                properties: {
                    bitmap: {
                        type: string;
                    };
                    $: {
                        type: string;
                        properties: {
                            vkey: {
                                type: string;
                            };
                        };
                        required: string[];
                        additionalProperties: boolean;
                    };
                    _: {
                        type: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "km-empty": {
                type: string;
            };
            "kvk-encoding-name": {
                type: string;
                enum: string[];
            };
            "kvk-layer-shift": {
                type: string;
                pattern: string;
            };
            "kvk-version": {
                type: string;
                pattern: string;
                enum: string[];
            };
            "km-version": {
                type: string;
                pattern: string;
            };
        };
    };
    ldmlKeyboard3: {
        $schema: string;
        additionalProperties: boolean;
        definitions: {
            any: {
                type: string;
            };
            display: {
                additionalProperties: boolean;
                properties: {
                    display: {
                        type: string;
                    };
                    keyId: {
                        type: string;
                    };
                    output: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            displayOptions: {
                additionalProperties: boolean;
                properties: {
                    baseCharacter: {
                        type: string;
                    };
                };
                type: string;
            };
            displays: {
                additionalProperties: boolean;
                properties: {
                    display: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    displayOptions: {
                        $ref: string;
                    };
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                type: string;
            };
            flick: {
                additionalProperties: boolean;
                properties: {
                    flickSegment: {
                        items: {
                            $ref: string;
                        };
                        minItems: number;
                        type: string;
                    };
                    id: {
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            flickSegment: {
                additionalProperties: boolean;
                properties: {
                    directions: {
                        type: string;
                    };
                    keyId: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            flicks: {
                additionalProperties: boolean;
                properties: {
                    flick: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                type: string;
            };
            form: {
                additionalProperties: boolean;
                properties: {
                    id: {
                        type: string;
                    };
                    scanCodes: {
                        items: {
                            $ref: string;
                        };
                        minItems: number;
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            forms: {
                additionalProperties: boolean;
                properties: {
                    form: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                type: string;
            };
            import: {
                additionalProperties: boolean;
                properties: {
                    base: {
                        type: string;
                    };
                    path: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            info: {
                additionalProperties: boolean;
                properties: {
                    author: {
                        type: string;
                    };
                    indicator: {
                        type: string;
                    };
                    layout: {
                        type: string;
                    };
                    name: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            key: {
                additionalProperties: boolean;
                properties: {
                    flickId: {
                        type: string;
                    };
                    gap: {
                        enum: string[];
                        type: string;
                    };
                    id: {
                        type: string;
                    };
                    layerId: {
                        type: string;
                    };
                    longPressDefaultKeyId: {
                        type: string;
                    };
                    longPressKeyIds: {
                        type: string;
                    };
                    multiTapKeyIds: {
                        type: string;
                    };
                    output: {
                        type: string;
                    };
                    stretch: {
                        enum: string[];
                        type: string;
                    };
                    width: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            keys: {
                additionalProperties: boolean;
                properties: {
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    key: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                type: string;
            };
            layer: {
                additionalProperties: boolean;
                properties: {
                    id: {
                        type: string;
                    };
                    modifiers: {
                        type: string;
                    };
                    row: {
                        items: {
                            $ref: string;
                        };
                        minItems: number;
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            layers: {
                additionalProperties: boolean;
                properties: {
                    formId: {
                        type: string;
                    };
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    layer: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    minDeviceWidth: {
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            locale: {
                additionalProperties: boolean;
                properties: {
                    id: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            locales: {
                additionalProperties: boolean;
                properties: {
                    locale: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                type: string;
            };
            reorder: {
                additionalProperties: boolean;
                properties: {
                    before: {
                        type: string;
                    };
                    from: {
                        type: string;
                    };
                    order: {
                        type: string;
                    };
                    preBase: {
                        type: string;
                    };
                    tertiary: {
                        type: string;
                    };
                    tertiaryBase: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            row: {
                additionalProperties: boolean;
                properties: {
                    keys: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            scanCodes: {
                additionalProperties: boolean;
                properties: {
                    codes: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            set: {
                additionalProperties: boolean;
                properties: {
                    id: {
                        type: string;
                    };
                    value: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            settings: {
                additionalProperties: boolean;
                properties: {
                    normalization: {
                        enum: string[];
                        type: string;
                    };
                };
                type: string;
            };
            special: {
                $ref: string;
            };
            stringVariable: {
                additionalProperties: boolean;
                properties: {
                    id: {
                        type: string;
                    };
                    value: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            transform: {
                additionalProperties: boolean;
                properties: {
                    from: {
                        type: string;
                    };
                    to: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            transformGroup: {
                additionalProperties: boolean;
                properties: {
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    reorder: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    transform: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                type: string;
            };
            transforms: {
                additionalProperties: boolean;
                properties: {
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    transformGroup: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    type: {
                        enum: string[];
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            uset: {
                additionalProperties: boolean;
                properties: {
                    id: {
                        type: string;
                    };
                    value: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            variables: {
                additionalProperties: boolean;
                properties: {
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    set: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    string: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    uset: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                };
                type: string;
            };
            version: {
                additionalProperties: boolean;
                properties: {
                    cldrVersion: {
                        enum: string[];
                        type: string;
                    };
                    number: {
                        type: string;
                    };
                };
                type: string;
            };
        };
        properties: {
            keyboard3: {
                additionalProperties: boolean;
                properties: {
                    conformsTo: {
                        enum: string[];
                        type: string;
                    };
                    displays: {
                        $ref: string;
                    };
                    flicks: {
                        $ref: string;
                    };
                    forms: {
                        $ref: string;
                    };
                    import: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    info: {
                        $ref: string;
                    };
                    keys: {
                        $ref: string;
                    };
                    layers: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    locale: {
                        type: string;
                    };
                    locales: {
                        $ref: string;
                    };
                    settings: {
                        $ref: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    transforms: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    variables: {
                        $ref: string;
                    };
                    version: {
                        $ref: string;
                    };
                    xmlns: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
        };
        required: string[];
        title: string;
        type: string;
    };
    ldmlKeyboardTest3: {
        $schema: string;
        additionalProperties: boolean;
        definitions: {
            any: {
                type: string;
            };
            backspace: {
                type: string;
            };
            check: {
                additionalProperties: boolean;
                properties: {
                    result: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            emit: {
                additionalProperties: boolean;
                properties: {
                    to: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            info: {
                additionalProperties: boolean;
                properties: {
                    author: {
                        type: string;
                    };
                    keyboard: {
                        type: string;
                    };
                    name: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            keystroke: {
                additionalProperties: boolean;
                properties: {
                    flick: {
                        type: string;
                    };
                    key: {
                        type: string;
                    };
                    longPress: {
                        type: string;
                    };
                    tapCount: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            repertoire: {
                additionalProperties: boolean;
                properties: {
                    chars: {
                        type: string;
                    };
                    name: {
                        type: string;
                    };
                    type: {
                        enum: string[];
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            special: {
                $ref: string;
            };
            startContext: {
                additionalProperties: boolean;
                properties: {
                    to: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
            test: {
                additionalProperties: boolean;
                properties: {
                    backspace: {
                        $ref: string;
                    };
                    check: {
                        $ref: string;
                    };
                    emit: {
                        $ref: string;
                    };
                    keystroke: {
                        $ref: string;
                    };
                    name: {
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    startContext: {
                        $ref: string;
                    };
                };
                required: string[];
                type: string;
            };
            tests: {
                additionalProperties: boolean;
                properties: {
                    name: {
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    test: {
                        items: {
                            $ref: string;
                        };
                        minItems: number;
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
        };
        properties: {
            keyboardTest3: {
                additionalProperties: boolean;
                properties: {
                    conformsTo: {
                        enum: string[];
                        type: string;
                    };
                    info: {
                        $ref: string;
                    };
                    repertoire: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    special: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    tests: {
                        items: {
                            $ref: string;
                        };
                        type: string;
                    };
                    xmlns: {
                        type: string;
                    };
                };
                required: string[];
                type: string;
            };
        };
        required: string[];
        title: string;
        type: string;
    };
    displayMap: {
        $ref: string;
        definitions: {
            displayMap: {
                type: string;
                properties: {
                    map: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                };
            };
            map: {
                type: string;
                properties: {
                    pua: {
                        type: string;
                    };
                    str: {
                        type: string;
                    };
                    unicode: {
                        type: string;
                    };
                    usages: {
                        anyOf: ({
                            type: string;
                            items: {
                                $ref: string;
                                type?: undefined;
                            };
                        } | {
                            type: string;
                            items: {
                                type: string;
                                $ref?: undefined;
                            };
                        })[];
                    };
                };
            };
            usage: {
                type: string;
                properties: {
                    filename: {
                        type: string;
                    };
                    count: {
                        type: string;
                    };
                };
            };
        };
    };
    touchLayoutClean: {
        $schema: string;
        $ref: string;
        $comment: string;
        description: string;
        definitions: {
            "touch-layout": {
                type: string;
                properties: {
                    tablet: {
                        $ref: string;
                    };
                    phone: {
                        $ref: string;
                    };
                    desktop: {
                        $ref: string;
                    };
                };
                minProperties: number;
                additionalProperties: boolean;
            };
            platform: {
                type: string;
                properties: {
                    font: {
                        $ref: string;
                    };
                    fontsize: {
                        $ref: string;
                    };
                    layer: {
                        $ref: string;
                    };
                    displayUnderlying: {
                        type: string;
                    };
                    defaultHint: {
                        type: string;
                        enum: string[];
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            layers: {
                type: string;
                items: {
                    $ref: string;
                };
                minItems: number;
            };
            layer: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    row: {
                        $ref: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "layer-id": {
                type: string;
                pattern: string;
            };
            rows: {
                type: string;
                items: {
                    $ref: string;
                };
                minItems: number;
            };
            row: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    key: {
                        $ref: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "row-id": {
                type: string;
                minimum: number;
                maximum: number;
            };
            keys: {
                type: string;
                items: {
                    $ref: string;
                };
                minItems: number;
            };
            key: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    text: {
                        type: string;
                    };
                    layer: {
                        $ref: string;
                    };
                    nextlayer: {
                        $ref: string;
                    };
                    font: {
                        $ref: string;
                    };
                    fontsize: {
                        $ref: string;
                    };
                    sp: {
                        $ref: string;
                    };
                    pad: {
                        $ref: string;
                    };
                    width: {
                        $ref: string;
                    };
                    sk: {
                        $ref: string;
                    };
                    flick: {
                        $ref: string;
                    };
                    multitap: {
                        $ref: string;
                    };
                    hint: {
                        type: string;
                    };
                };
                anyOf: {
                    required: string[];
                }[];
                additionalProperties: boolean;
            };
            "key-id": {
                type: string;
                pattern: string;
            };
            "key-sp": {
                type: string;
                enum: number[];
            };
            "key-pad": {
                type: string;
                minimum: number;
                maximum: number;
            };
            "key-width": {
                type: string;
                minimum: number;
                maximum: number;
            };
            subkeys: {
                type: string;
                items: {
                    $ref: string;
                };
                minItems: number;
            };
            subkey: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    text: {
                        type: string;
                    };
                    layer: {
                        $ref: string;
                    };
                    nextlayer: {
                        $ref: string;
                    };
                    font: {
                        $ref: string;
                    };
                    fontsize: {
                        $ref: string;
                    };
                    sp: {
                        $ref: string;
                    };
                    pad: {
                        $ref: string;
                    };
                    width: {
                        $ref: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            flick: {
                type: string;
                patternProperties: {
                    "^(n|s|e|w|ne|nw|se|sw)$": {
                        $ref: string;
                    };
                };
                minProperties: number;
                additionalProperties: boolean;
            };
            "font-spec": {
                type: string;
            };
            "fontsize-spec": {
                type: string;
            };
        };
    };
    touchLayout: {
        $schema: string;
        $ref: string;
        $comment: string;
        description: string;
        definitions: {
            "touch-layout": {
                type: string;
                properties: {
                    tablet: {
                        $ref: string;
                    };
                    phone: {
                        $ref: string;
                    };
                    desktop: {
                        $ref: string;
                    };
                };
            };
            platform: {
                type: string;
                properties: {
                    font: {
                        $ref: string;
                    };
                    fontsize: {
                        $ref: string;
                    };
                    layer: {
                        $ref: string;
                    };
                    displayUnderlying: {
                        type: string;
                    };
                    defaultHint: {
                        type: string;
                        enum: string[];
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            layers: {
                type: string;
                items: {
                    $ref: string;
                };
            };
            layer: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    row: {
                        $ref: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "layer-id": {
                type: string;
                pattern: string;
            };
            rows: {
                type: string;
                items: {
                    $ref: string;
                };
            };
            row: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    key: {
                        $ref: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            "row-id": {
                oneOf: ({
                    type: string;
                    minimum: number;
                    maximum: number;
                    pattern?: undefined;
                } | {
                    type: string;
                    pattern: string;
                    minimum?: undefined;
                    maximum?: undefined;
                })[];
            };
            keys: {
                type: string;
                items: {
                    $ref: string;
                };
            };
            key: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    text: {
                        type: string;
                    };
                    layer: {
                        $ref: string;
                    };
                    nextlayer: {
                        $ref: string;
                    };
                    fontsize: {
                        $ref: string;
                    };
                    font: {
                        $ref: string;
                    };
                    dk: {
                        type: string;
                    };
                    sp: {
                        $ref: string;
                    };
                    pad: {
                        $ref: string;
                    };
                    width: {
                        $ref: string;
                    };
                    sk: {
                        $ref: string;
                    };
                    flick: {
                        $ref: string;
                    };
                    multitap: {
                        $ref: string;
                    };
                    hint: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
            };
            numeric: {
                oneOf: ({
                    type: string;
                    pattern: string;
                } | {
                    type: string;
                    pattern?: undefined;
                })[];
            };
            "key-id": {
                type: string;
                pattern: string;
            };
            subkeys: {
                type: string;
                items: {
                    $ref: string;
                };
            };
            subkey: {
                type: string;
                properties: {
                    id: {
                        $ref: string;
                    };
                    text: {
                        type: string;
                    };
                    layer: {
                        $ref: string;
                    };
                    nextlayer: {
                        $ref: string;
                    };
                    sp: {
                        $ref: string;
                    };
                    pad: {
                        $ref: string;
                    };
                    width: {
                        $ref: string;
                    };
                    fontsize: {
                        $ref: string;
                    };
                    font: {
                        $ref: string;
                    };
                    dk: {
                        type: string;
                    };
                    default: {
                        type: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            flick: {
                type: string;
                patternProperties: {
                    "^(n|s|e|w|ne|nw|se|sw)$": {
                        $ref: string;
                    };
                };
                additionalProperties: boolean;
            };
            "font-spec": {
                type: string;
            };
            "fontsize-spec": {
                type: string;
            };
        };
    };
    keyboard_info: {
        $schema: string;
        $ref: string;
        definitions: {
            KeyboardInfo: {
                type: string;
                properties: {
                    id: {
                        type: string;
                    };
                    name: {
                        type: string;
                    };
                    authorName: {
                        type: string;
                    };
                    authorEmail: {
                        type: string;
                        format: string;
                    };
                    description: {
                        type: string;
                    };
                    license: {
                        type: string;
                        enum: string[];
                    };
                    languages: {
                        anyOf: ({
                            type: string;
                            items: {
                                type: string;
                            };
                            uniqueItems: boolean;
                            $ref?: undefined;
                        } | {
                            $ref: string;
                            type?: undefined;
                            items?: undefined;
                            uniqueItems?: undefined;
                        })[];
                    };
                    lastModifiedDate: {
                        type: string;
                        format: string;
                    };
                    packageFilename: {
                        type: string;
                        pattern: string;
                    };
                    packageFileSize: {
                        type: string;
                    };
                    jsFilename: {
                        type: string;
                        pattern: string;
                    };
                    jsFileSize: {
                        type: string;
                    };
                    isRTL: {
                        type: string;
                    };
                    encodings: {
                        type: string;
                        items: {
                            type: string;
                            enum: string[];
                        };
                    };
                    packageIncludes: {
                        type: string;
                        items: {
                            type: string;
                            enum: string[];
                        };
                    };
                    version: {
                        type: string;
                    };
                    minKeymanVersion: {
                        type: string;
                        pattern: string;
                    };
                    helpLink: {
                        type: string;
                        pattern: string;
                    };
                    platformSupport: {
                        $ref: string;
                    };
                    sourcePath: {
                        type: string;
                        pattern: string;
                    };
                    related: {
                        type: string;
                        patternProperties: {
                            ".": {
                                $ref: string;
                            };
                        };
                        additionalProperties: boolean;
                    };
                    deprecated: {
                        type: string;
                    };
                };
                required: string[];
            };
            KeyboardLanguageInfo: {
                type: string;
                patternProperties: {
                    ".": {
                        $ref: string;
                    };
                };
                additionalProperties: boolean;
            };
            KeyboardLanguageInfoItem: {
                type: string;
                properties: {
                    font: {
                        $ref: string;
                    };
                    oskFont: {
                        $ref: string;
                    };
                    examples: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                    displayName: {
                        type: string;
                    };
                    languageName: {
                        type: string;
                    };
                    scriptName: {
                        type: string;
                    };
                    regionName: {
                        type: string;
                    };
                };
                required: any[];
                additionalProperties: boolean;
            };
            KeyboardFontInfo: {
                type: string;
                properties: {
                    family: {
                        type: string;
                    };
                    source: {
                        type: string;
                        items: {
                            type: string;
                        };
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            KeyboardExampleInfo: {
                type: string;
                properties: {
                    keys: {
                        type: string;
                    };
                    text: {
                        type: string;
                    };
                    note: {
                        type: string;
                    };
                };
                required: string[];
                additionalProperties: boolean;
            };
            KeyboardPlatformInfo: {
                type: string;
                patternProperties: {
                    "^(windows|macos|desktopWeb|ios|android|mobileWeb|linux)$": {
                        type: string;
                        enum: string[];
                    };
                };
                required: any[];
                additionalProperties: boolean;
            };
            KeyboardRelatedInfo: {
                type: string;
                properties: {
                    deprecates: {
                        type: string;
                    };
                    deprecatedBy: {
                        type: string;
                    };
                };
                required: any[];
                additionalProperties: boolean;
            };
        };
    };
    kmp: {
        $schema: string;
        $ref: string;
        definitions: {
            package: {
                type: string;
                properties: {
                    system: {
                        $ref: string;
                    };
                    options: {
                        $ref: string;
                    };
                    startMenu: {
                        $ref: string;
                    };
                    strings: {
                        $ref: string;
                    };
                    files: {
                        $ref: string;
                    };
                    keyboards: {
                        $ref: string;
                    };
                    lexicalModels: {
                        $ref: string;
                    };
                    info: {
                        $ref: string;
                    };
                    relatedPackages: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            system: {
                type: string;
                properties: {
                    keymanDeveloperVersion: {
                        type: string;
                    };
                    fileVersion: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            options: {
                type: string;
                properties: {
                    readmeFile: {
                        type: string;
                    };
                    graphicFile: {
                        type: string;
                    };
                    licenseFile: {
                        type: string;
                    };
                    welcomeFile: {
                        type: string;
                    };
                    executeProgram: {
                        type: string;
                    };
                    msiFilename: {
                        type: string;
                    };
                    msiOptions: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
            };
            startMenu: {
                type: string;
                properties: {
                    folder: {
                        type: string;
                    };
                    addUninstallEntry: {
                        type: string;
                    };
                    items: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                };
                additionalProperties: boolean;
            };
            startMenuItem: {
                type: string;
                properties: {
                    name: {
                        type: string;
                    };
                    filename: {
                        type: string;
                    };
                    arguments: {
                        type: string;
                    };
                    icon: {
                        type: string;
                    };
                    location: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            strings: {
                type: string;
                patternProperties: {
                    ".": {
                        type: string;
                    };
                };
                additionalProperties: boolean;
            };
            files: {
                type: string;
                items: {
                    $ref: string;
                };
            };
            file: {
                type: string;
                properties: {
                    name: {
                        type: string;
                    };
                    description: {
                        type: string;
                    };
                    copyLocation: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            keyboards: {
                type: string;
                items: {
                    $ref: string;
                };
            };
            keyboard: {
                type: string;
                properties: {
                    name: {
                        type: string;
                    };
                    id: {
                        type: string;
                    };
                    version: {
                        type: string;
                    };
                    oskFont: {
                        type: string;
                    };
                    displayFont: {
                        type: string;
                    };
                    rtl: {
                        type: string;
                    };
                    languages: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                    examples: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                    webOskFonts: {
                        type: string;
                        items: {
                            type: string;
                        };
                    };
                    webDisplayFonts: {
                        type: string;
                        items: {
                            type: string;
                        };
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            keyboardLanguage: {
                type: string;
                properties: {
                    name: {
                        type: string;
                    };
                    id: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            info: {
                type: string;
                properties: {
                    website: {
                        $ref: string;
                    };
                    version: {
                        $ref: string;
                    };
                    name: {
                        $ref: string;
                    };
                    copyright: {
                        $ref: string;
                    };
                    author: {
                        $ref: string;
                    };
                    description: {
                        $ref: string;
                    };
                };
                additionalProperties: boolean;
            };
            infoItem: {
                type: string;
                properties: {
                    description: {
                        type: string;
                    };
                    url: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            lexicalModels: {
                type: string;
                items: {
                    $ref: string;
                };
            };
            lexicalModel: {
                type: string;
                properties: {
                    name: {
                        type: string;
                    };
                    id: {
                        type: string;
                    };
                    version: {
                        type: string;
                    };
                    rtl: {
                        type: string;
                    };
                    languages: {
                        type: string;
                        items: {
                            $ref: string;
                        };
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            keyboardExample: {
                type: string;
                properties: {
                    id: {
                        type: string;
                    };
                    keys: {
                        type: string;
                    };
                    text: {
                        type: string;
                    };
                    note: {
                        type: string;
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
            relatedPackage: {
                type: string;
                properties: {
                    id: {
                        type: string;
                    };
                    relationship: {
                        type: string;
                        enum: string[];
                    };
                };
                additionalProperties: boolean;
                required: string[];
            };
        };
    };
};
export default Schemas;
//# sourceMappingURL=schemas.d.ts.map