declare const _default: {
    $schema: string;
    additionalProperties: boolean;
    definitions: {
        any: {
            type: string;
        };
        backspace: {
            type: string;
        };
        check: {
            additionalProperties: boolean;
            properties: {
                result: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        emit: {
            additionalProperties: boolean;
            properties: {
                to: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        info: {
            additionalProperties: boolean;
            properties: {
                author: {
                    type: string;
                };
                keyboard: {
                    type: string;
                };
                name: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        keystroke: {
            additionalProperties: boolean;
            properties: {
                flick: {
                    type: string;
                };
                key: {
                    type: string;
                };
                longPress: {
                    type: string;
                };
                tapCount: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        repertoire: {
            additionalProperties: boolean;
            properties: {
                chars: {
                    type: string;
                };
                name: {
                    type: string;
                };
                type: {
                    enum: string[];
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        special: {
            $ref: string;
        };
        startContext: {
            additionalProperties: boolean;
            properties: {
                to: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        test: {
            additionalProperties: boolean;
            properties: {
                backspace: {
                    $ref: string;
                };
                check: {
                    $ref: string;
                };
                emit: {
                    $ref: string;
                };
                keystroke: {
                    $ref: string;
                };
                name: {
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                startContext: {
                    $ref: string;
                };
            };
            required: string[];
            type: string;
        };
        tests: {
            additionalProperties: boolean;
            properties: {
                name: {
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                test: {
                    items: {
                        $ref: string;
                    };
                    minItems: number;
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
    };
    properties: {
        keyboardTest3: {
            additionalProperties: boolean;
            properties: {
                conformsTo: {
                    enum: string[];
                    type: string;
                };
                info: {
                    $ref: string;
                };
                repertoire: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                special: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                tests: {
                    items: {
                        $ref: string;
                    };
                    type: string;
                };
                xmlns: {
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
    };
    required: string[];
    title: string;
    type: string;
};
export default _default;
//# sourceMappingURL=ldml-keyboardtest3.schema.d.ts.map