/**
 * Extracts the font-family from an in-memory TTF or WOFF blob in `source`
 * parameter.
 *
 * @param source   In-memory TTF or WOFF font blob
 *
 * @throws Uncaught exceptions from ttfMeta.promise if the font file is invalid.
 *
 * @returns If the file is invalid or cannot be parsed, returns `null`,
 *          otherwise returns the font family as a string.
 */
export declare function getFontFamily(source: Uint8Array): Promise<string>;
/**
 * Extracts the font-family from an in-memory TTF or WOFF blob in `source`
 * parameter.
 *
 * @param source   In-memory TTF or WOFF font blob
 *
 * @throws Uncaught exceptions from ttfMeta.promise if the font file is invalid.
 *
 * @returns If the file is invalid or cannot be parsed, returns `null`,
 *          otherwise returns the font family as a string.
 */
export declare function getFontFamilySync(source: Uint8Array): string;
//# sourceMappingURL=font-family.d.ts.map