/**
 * Matches only a GitHub permanent raw URI with a commit hash, without any other
 * components; note hash is called branch to match other URI formats
 */
export declare const GITHUB_STABLE_SOURCE: RegExp;
/**
 * Matches any GitHub git resource raw 'user content' URI which can be
 * translated to a permanent URI with a commit hash
 */
export declare const GITHUB_RAW_URI: RegExp;
/**
 * Matches any GitHub git resource raw URI which can be translated to a
 * permanent URI with a commit hash
 */
export declare const GITHUB_URI: RegExp;
/**
 * Matches any GitHub git resource raw URI which can be translated to a
 * permanent URI with a commit hash, with the http[s] protocol optional, for
 * matching user-supplied URLs. groups are: `owner`, `repo`, `branch`, and
 * `path`.
 */
export declare const GITHUB_URI_OPTIONAL_PROTOCOL: RegExp;
export interface GitHubRegexMatchArray extends RegExpMatchArray {
    groups?: {
        owner?: string;
        repo?: string;
        branch?: string;
        path?: string;
    };
}
//# sourceMappingURL=github-urls.d.ts.map