/**
 * A keyboard package filename SHOULD adhere to this pattern (including file
 * extension), lower case alphanumeric and underscore only allowed (a-z, _ only
 * for first letter).
 */
export declare const KEYBOARD_ID_PATTERN_PACKAGE: RegExp;
/**
 * A lexical model package filename SHOULD adhere to this pattern (including
 * file extension). There are three components to the filename: author, bcp47,
 * and uniq, separated by period. The filename ends in .model.kps or .model.kmp.
 * Each of the author, bcp47, and uniq sections may contain lowercase
 * alphanumeric, underscore characters, and the bcp47 section additionally may
 * contain hyphen. Digits are not permitted as first letter of each section.
 *
 * Despite including a bcp47 tag as part of the filename, it is informative only,
 * and is not regarded as part of the metadata for the lexical model.
 */
export declare const MODEL_ID_PATTERN_PACKAGE: RegExp;
/**
 * Filenames of files contained in a package MAY adhere to this pattern for
 * optimum cross-platform compatibility. This is the basename portion of the
 * filename, and is case-insensitive.
 */
export declare const CONTENT_FILE_BASENAME_PATTERN: RegExp;
/**
 * Extensions of files contained in a package MAY adhere to this pattern for optimum
 * cross-platform compatibility. This is the extension portion of the filename,
 * and should be lower case, and may be empty.
 */
export declare const CONTENT_FILE_EXTENSION_PATTERN: RegExp;
//# sourceMappingURL=source-filename-patterns.d.ts.map