import { TouchLayout } from "@keymanapp/common-types";
import TouchLayoutFile = TouchLayout.TouchLayoutFile;
export interface TouchLayoutFileWriterOptions {
    formatted?: boolean;
}
export declare class TouchLayoutFileWriter {
    options: TouchLayoutFileWriterOptions;
    constructor(options?: TouchLayoutFileWriterOptions);
    /**
     * Writes the touch layout to a .keyman-touch-layout JSON file
     * @param source TouchLayoutFile
     * @returns Uint8Array, the .keyman-touch-layout file
     */
    write(source: TouchLayoutFile): Uint8Array;
    /**
     * Gets the output as a JSON string
     */
    toJSONString(source: TouchLayoutFile): string;
    /**
     * Compiles the touch layout file into a KeymanWeb-compatible JSON-style
     * object string. In the future, this may be optimized to remove unnecessary
     * quoting of property names, and remove unused properties, as this string
     * is embedded into .js code.
     * @param source
     * @returns string
     */
    compile(source: TouchLayoutFile): string;
    fixup(source: TouchLayoutFile): TouchLayoutFile;
}
//# sourceMappingURL=keyman-touch-layout-file-writer.d.ts.map