import { constants } from '@keymanapp/ldml-keyboard-constants';
import { build_strs_index } from "./build-strs.js";
;
;
export function build_disp(kmxplus, sect_strs) {
    if (!kmxplus.disp.disps.length && !kmxplus.disp.baseCharacter.value) {
        return null;
    }
    const disp = {
        ident: constants.hex_section_id(constants.section.disp),
        size: constants.length_disp + constants.length_disp_item * kmxplus.disp.disps.length,
        _offset: 0,
        count: kmxplus.disp.disps.length,
        baseCharacter: build_strs_index(sect_strs, kmxplus.disp.baseCharacter),
        items: []
    };
    for (const item of kmxplus.disp.disps) {
        disp.items.push({
            to: build_strs_index(sect_strs, item.to),
            id: build_strs_index(sect_strs, item.id),
            display: build_strs_index(sect_strs, item.display),
        });
    }
    return disp;
}
//# sourceMappingURL=build-disp.js.map