import { KMXPlus, LdmlKeyboardTypes } from "@keymanapp/common-types";
import { BUILDER_STR_REF, BUILDER_STRS } from "./build-strs.js";
import { BUILDER_SECTION, BUILDER_U32CHAR } from "./builder-section.js";
import { BUILDER_USET, BUILDER_USET_REF } from "./build-uset.js";
import Elem = KMXPlus.Elem;
/** return from build_elem_index */
export type BUILDER_ELEM_REF = number;
interface BUILDER_ELEM_ELEMENT {
    element: BUILDER_STR_REF | BUILDER_USET_REF | BUILDER_U32CHAR;
    flags: number;
    _value: string;
}
interface BUILDER_ELEM_STRING {
    offset: number;
    length: number;
    items: BUILDER_ELEM_ELEMENT[];
    _value: LdmlKeyboardTypes.ElementString;
}
/**
 * Builder for the 'elem' section
 */
export interface BUILDER_ELEM extends BUILDER_SECTION {
    count: number;
    strings: BUILDER_ELEM_STRING[];
}
export declare function build_elem(source_elem: Elem, sect_strs: BUILDER_STRS, sect_uset: BUILDER_USET): BUILDER_ELEM;
export declare function build_elem_index(sect_elem: BUILDER_ELEM, value: LdmlKeyboardTypes.ElementString): BUILDER_ELEM_REF;
export {};
//# sourceMappingURL=build-elem.d.ts.map