import { KMXPlus } from "@keymanapp/common-types";
import { BUILDER_STR_REF, BUILDER_STRS } from "./build-strs.js";
import { BUILDER_LIST, BUILDER_LIST_REF } from "./build-list.js";
import { BUILDER_SECTION, BUILDER_U32CHAR } from "./builder-section.js";
import KeysFlick = KMXPlus.KeysFlick;
import KMXPlusData = KMXPlus.KMXPlusData;
/**
 * This struct is a single <key> in the keys keybag
 */
interface BUILDER_KEYS_KEY {
    to: BUILDER_STR_REF | BUILDER_U32CHAR;
    flags: number;
    id: BUILDER_STR_REF;
    _id: string;
    switch: BUILDER_STR_REF;
    width: number;
    longPress: BUILDER_LIST_REF;
    longPressDefault: BUILDER_STR_REF;
    multiTap: BUILDER_LIST_REF;
    flicks: number;
}
/**
 * This is a <flicks>, a list of <flick> elements.
 */
interface BUILDER_KEYS_FLICKS {
    count: number;
    flick: number;
    id: BUILDER_STR_REF;
    _id: string;
    _flicks: KeysFlick[];
}
/**
 * This is a single <flick> element.
 */
interface BUILDER_KEYS_FLICK {
    directions: BUILDER_LIST_REF;
    to: BUILDER_STR_REF;
}
interface BUILDER_KEYS_KMAP {
    vkey: number;
    mod: number;
    key: number;
}
/**
 * Builder for the 'keys' section
 */
export interface BUILDER_KEYS extends BUILDER_SECTION {
    keyCount: number;
    flicksCount: number;
    flickCount: number;
    kmapCount: number;
    keys: BUILDER_KEYS_KEY[];
    flicks: BUILDER_KEYS_FLICKS[];
    flick: BUILDER_KEYS_FLICK[];
    kmap: BUILDER_KEYS_KMAP[];
}
export declare function build_keys(kmxplus: KMXPlusData, sect_strs: BUILDER_STRS, sect_list: BUILDER_LIST): BUILDER_KEYS;
export {};
//# sourceMappingURL=build-keys.d.ts.map