import { KMXPlus } from "@keymanapp/common-types";
import { BUILDER_ELEM, BUILDER_ELEM_REF } from "./build-elem.js";
import { BUILDER_STRS, BUILDER_STR_REF } from "./build-strs.js";
import { BUILDER_SECTION } from "./builder-section.js";
import Bksp = KMXPlus.Bksp;
import Tran = KMXPlus.Tran;
interface BUILDER_TRAN_GROUP {
    type: number;
    count: number;
    index: number;
}
interface BUILDER_TRAN_TRANSFORM {
    from: BUILDER_STR_REF;
    to: BUILDER_STR_REF;
    mapFrom: BUILDER_ELEM_REF;
    mapTo: BUILDER_ELEM_REF;
}
interface BUILDER_TRAN_REORDER {
    elements: BUILDER_ELEM_REF;
    before: BUILDER_ELEM_REF;
}
export interface BUILDER_TRAN extends BUILDER_SECTION {
    groupCount: number;
    transformCount: number;
    reorderCount: number;
    groups: BUILDER_TRAN_GROUP[];
    transforms: BUILDER_TRAN_TRANSFORM[];
    reorders: BUILDER_TRAN_REORDER[];
}
/**
* Builder for the 'tran', 'finl', and 'bksp' sections, all of which use the BUILDER_TRAN layout
*/
export declare function build_tran(source_tran: Tran | Bksp, sect_strs: BUILDER_STRS, sect_elem: BUILDER_ELEM): BUILDER_TRAN;
export {};
//# sourceMappingURL=build-tran.d.ts.map