import { KMXPlus } from "@keymanapp/common-types";
import { BUILDER_STR_REF, BUILDER_STRS } from "./build-strs.js";
import { BUILDER_SECTION, BUILDER_U32CHAR } from "./builder-section.js";
import KMXPlusData = KMXPlus.KMXPlusData;
import StrsItem = KMXPlus.StrsItem;
import UsetItem = KMXPlus.UsetItem;
/** reference from build_uset_index */
export type BUILDER_USET_REF = number;
interface BUILDER_USET_USET {
    range: number;
    count: number;
    pattern: BUILDER_STR_REF;
    _pattern: StrsItem;
}
interface BUILDER_USET_RANGE {
    start: BUILDER_U32CHAR;
    end: BUILDER_U32CHAR;
}
export interface BUILDER_USET extends BUILDER_SECTION {
    usetCount: number;
    rangeCount: number;
    usets: BUILDER_USET_USET[];
    ranges: BUILDER_USET_RANGE[];
}
/**
* Builder for the 'uset' section
*/
export declare function build_uset(kmxplus: KMXPlusData, sect_strs: BUILDER_STRS): BUILDER_USET;
/**
 * @returns uset index
 */
export declare function build_uset_index(sect_uset: BUILDER_USET, value: UsetItem): number;
export {};
//# sourceMappingURL=build-uset.d.ts.map