/**
 * Verifies that an id passed in is valid as an identifier for a Keyman .kmn
 * keyboard: starts with alpha or underscore and remainder is alphanumeric
 * @param id
 * @returns
 */
export declare function isValidKeymanKeyboardId(id: string): boolean;
/**
 * Verifies that an id passed in is valid as an identifier for an LDML xml
 * keyboard: starts with alpha or underscore and remainder is alphanumeric.
 * Note that this test is not the same as the CLDR test for valid LDML xml
 * filename, as this test has a narrower validity policy to match the Keyman
 * implementation requirements.
 * @param id
 * @returns
 */
export declare function isValidLdmlKeyboardId(id: string): boolean;
/**
 * Verifies that an id passed in is valid as an identifier for a Keyman
 * lexical model: starts with alpha or underscore and remainder is alphanumeric,
 * in three components -- author.bcp47.uniq
 * @param id
 * @returns
 */
export declare function isValidLexicalModelId(id: string): boolean;
//# sourceMappingURL=valid-ids.d.ts.map