import { XMLParser, XMLBuilder } from 'fast-xml-parser';
export type KeymanXMLType = 'keyboard3' | 'keyboardTest3' | 'kps' | 'kvks' | 'kpj';
/** wrapper for XML parsing support */
export declare class KeymanXMLReader {
    type: KeymanXMLType;
    constructor(type: KeymanXMLType);
    /** move `{ $abc: 4 }` into `{ $: { abc: 4 } }` */
    private static fixupDollarAttributes;
    /**
     * Requires attribute prefix @__ (double underscore)
     * For attributes, just remove @__ and continue.
     * For objects, replace any empty string "" with an empty object {} */
    private static fixupEmptyStringToEmptyObject;
    /**
     * Replace:
     * ```json
     * [ { "info": [], ":@": { "abc": "def" } }]
     * ```
     * with:
     * ```json
     * [{"$": { "abc": "def" }, "#name": "info" }]
     * ```
     * see https://github.com/NaturalIntelligence/fast-xml-parser/blob/master/docs/v4/2.XMLparseOptions.md#preserveorder
     * @param data input data
     */
    private static fixupPreserveOrder;
    /** takes an 'object' with a property `:@` containing attrs, and one other property with the object name */
    private static fixupPreserveOrderObject;
    parse(data: string): any;
    parser(): XMLParser;
}
/** wrapper for XML generation support */
export declare class KeymanXMLWriter {
    type: KeymanXMLType;
    private static fixDataForWrite;
    write(data: any): string;
    constructor(type: KeymanXMLType);
    builder(): XMLBuilder;
}
//# sourceMappingURL=xml-utils.d.ts.map