// NOTE: this is a copy of common/web/types/test/kvk/test-kvk-utils.ts
import 'mocha';
import { assert } from 'chai';
import { Constants } from '@keymanapp/common-types';
var USVirtualKeyCodes = Constants.USVirtualKeyCodes;
export function verify_khmer_angkor(vk) {
    assert.equal(vk.header.flags, 8 /* VisualKeyboardHeaderFlags.kvkhAltGr */);
    assert.equal(vk.header.associatedKeyboard, 'khmer_angkor');
    assert.equal(vk.header.ansiFont.name, 'Arial');
    assert.equal(vk.header.ansiFont.size, -12);
    assert.equal(vk.header.unicodeFont.name, 'Khmer Busra Kbd');
    assert.equal(vk.header.unicodeFont.size, 16);
    assert.equal(vk.keys.length, 186);
    assert.equal(vk.keys[0].flags, 2 /* VisualKeyboardKeyFlags.kvkkUnicode */);
    assert.equal(vk.keys[0].vkey, USVirtualKeyCodes.K_B);
    assert.equal(vk.keys[0].shift, 64 /* VisualKeyboardShiftState.KVKS_RALT */);
    assert.equal(vk.keys[0].text, 'ឞ');
    assert.equal(vk.keys[185].flags, 2 /* VisualKeyboardKeyFlags.kvkkUnicode */);
    assert.equal(vk.keys[185].vkey, USVirtualKeyCodes.K_COMMA);
    assert.equal(vk.keys[185].shift, 1 /* VisualKeyboardShiftState.KVKS_SHIFT */);
    assert.equal(vk.keys[185].text, '');
}
export function verify_balochi_inpage(vk) {
    assert.equal(vk.header.flags, 8 /* VisualKeyboardHeaderFlags.kvkhAltGr */ | 2 /* VisualKeyboardHeaderFlags.kvkhDisplayUnderlying */);
    assert.equal(vk.header.associatedKeyboard, 'balochi_inpage');
    assert.equal(vk.header.unicodeFont.name, 'Lateef');
    assert.equal(vk.header.unicodeFont.size, 14);
    assert.equal(vk.keys.length, 147);
    assert.equal(vk.keys[0].flags, 2 /* VisualKeyboardKeyFlags.kvkkUnicode */);
    assert.equal(vk.keys[0].vkey, USVirtualKeyCodes.K_BKQUOTE);
    assert.equal(vk.keys[0].shift, 64 /* VisualKeyboardShiftState.KVKS_RALT */);
    assert.equal(vk.keys[0].text, '‍');
    assert.equal(vk.keys[30].flags, 2 /* VisualKeyboardKeyFlags.kvkkUnicode */ | 1 /* VisualKeyboardKeyFlags.kvkkBitmap */);
    assert.equal(vk.keys[30].vkey, USVirtualKeyCodes.K_COMMA);
    assert.equal(vk.keys[30].shift, 8 /* VisualKeyboardShiftState.KVKS_LCTRL */);
    assert.equal(vk.keys[30].text, '');
    assert.equal(vk.keys[30].bitmap.byteLength, 35766);
}
//# sourceMappingURL=kvk-utils.tests.js.map